import sys
import string
import traceback
import socket

PORT = 8578			#port for communicating with storagerIndexer

def writeDebugInfo(msg):
	debugFile = open("c:\\debug.txt", "a+")
	debugFile.write(msg)
	debugFile.close()
	return

def tracebackAsString(limit):
	type, value, tb = sys.exc_info()
	aList = traceback.format_exception(type, value, tb, limit)
	formattedString = ""
	for s in aList:
		formattedString = formattedString + s + "\n"
	return formattedString

def startCollectionBuild(self, REQUEST, AUTHENTICATED_USER):
	try:
		storageFolder = self.aq_parent["storageFolder"]
		tempDirectory = self.aq_parent["tempDirectory"]
		mgDir = self.aq_parent["mgDir"]
	except Exception, data:
		s = "Error getting Zope properties for MG collection build: " + `data` + "\n"
		writeDebugInfo(s)
		return s

	userName = `AUTHENTICATED_USER`
	serverName = REQUEST["SERVER_NAME"]

	try:
		clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		buildRequest = ("build" + "|"
							+ userName + "|"
							+ tempDirectory + "|"
							+ storageFolder + "|"
							+ mgDir)
		clientsock.connect(serverName, PORT)
		clientsock.send(buildRequest)
		clientsock.close()
	except Exception, data:
		s = "Error communicating with storager: " + `data` + "\n"
		writeDebugInfo(s)
		try:
			clientsock.close()
		except:
			pass
		return s

	return "MG collection build started. Currently there is no notification of its completion.\n"